#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2500one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 2500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2500one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one25004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


 
                         
# -------------------------------------------------------------------------------------------------
# 2500
# -------------------------------------------------------------------------------------------------                                          
shot2one25004xi = {
                  1:'0x0y2499z',
                  2:'0x1655y1873z',
                  3:'0x75y2498z',
                  4:'1001x1668y1569z',
                  5:'1021x827y2126z',
                  6:'1046x760y2139z',
                  7:'1049x1343y1828z',
                  8:'1062x1846y1308z',
                  9:'1078x1600y1589z',
                  10:'1079x1961y1111z',
                  11:'107x104y2495z',
                  12:'1106x1272y1845z',
                  13:'113x2236y1111z',
                  14:'1150x1529y1608z',
                  15:'1150x1777y1329z',
                  16:'1158x1199y1862z',
                  17:'1174x1893y1133z',
                  18:'119x127y2493z',
                  19:'11x299y2482z',
                  20:'1205x1124y1879z',
                  21:'1218x1454y1627z',
                  22:'1233x1704y1350z',
                  23:'1248x1047y1895z',
                  24:'1265x1819y1156z',
                  25:'1282x1376y1646z',
                  26:'1286x969y1911z',
                  27:'128x152y2492z',
                  28:'1312x1626y1371z',
                  29:'1319x890y1927z',
                  30:'1340x1296y1665z',
                  31:'1351x1741y1178z',
                  32:'135x179y2489z',
                  33:'1386x1545y1392z',
                  34:'1394x1213y1683z',
                  35:'139x206y2487z',
                  36:'140x264y2482z',
                  37:'141x235y2484z',
                  38:'142x305y2578z',
                  39:'1433x1659y1200z',
                  40:'143x2073y1388z',
                  41:'1442x1128y1702z',
                  42:'1455x1460y1412z',
                  43:'1485x1041y1720z',
                  44:'14x20y2499z',
                  45:'1509x1573y1222z',
                  46:'1519x1372y1433z',
                  47:'1578x1282y1453z',
                  48:'1581x1484y1243z',
                  49:'1631x1189y1474z',
                  50:'1647x1391y1265z',
                  51:'165x1887y1630z',
                  52:'169x1608y1906z',
                  53:'1707x1295y1287z',
                  54:'194x2312y929z',
                  55:'229x2216y1133z',
                  56:'24x273y2484z',
                  57:'250x1578y1922z',
                  58:'250x2049y1409z',
                  59:'261x1860y1649z',
                  60:'26x42y2499z',
                  61:'2x25y2499z',
                  62:'2x50y2499z',
                  63:'314x2290y952z',
                  64:'328x1544y1938z',
                  65:'343x2189y1155z',
                  66:'355x1827y1668z',
                  67:'355x2019y1430z',
                  68:'35x2092y1367z',
                  69:'35x247y2487z',
                  70:'36x65y2498z',
                  71:'403x1506y1953z',
                  72:'431x2261y975z',
                  73:'43x220y2489z',
                  74:'446x1790y1686z',
                  75:'44x89y2497z',
                  76:'455x2157y1178z',
                  77:'457x1984y1450z',
                  78:'475x1464y1969z',
                  79:'48x193y2492z',
                  80:'49x114y2496z',
                  81:'51x140y2495z',
                  82:'51x167y2493z',
                  83:'534x1748y1705z',
                  84:'544x1419y1984z',
                  85:'547x2225y998z',
                  86:'556x1943y1470z',
                  87:'564x2119y1200z',
                  88:'610x1370y1999z',
                  89:'619x1701y1723z',
                  90:'652x1897y1490z',
                  91:'660x2184y1021z',
                  92:'66x1909y1611z',
                  93:'670x2075y1221z',
                  94:'671x1318y2014z',
                  95:'700x1651y1741z',
                  96:'729x1264y2029z',
                  97:'73x2328y905z',
                  98:'745x1847y1510z',
                  99:'770x2137y1043z',
                  100:'773x2025y1243z',
                  101:'778x1596y1759z',
                  102:'784x1207y2043z',
                  103:'78x61y2498z',
                  104:'834x1148y2058z',
                  105:'834x1791y1530z',
                  106:'852x1538y1776z',
                  107:'85x1634y1890z',
                  108:'873x1971y1265z',
                  109:'876x2084y1066z',
                  110:'880x1086y2072z',
                  111:'919x1732y1550z',
                  112:'921x1023y2086z',
                  113:'922x1476y1794z',
                  114:'94x81y2496z',
                  115:'959x959y2099z',
                  116:'970x1911y1286z',
                  117:'979x2025y1089z',
                  118:'988x1411y1811z',
                  119:'992x893y2113z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2500one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2500one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2500ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2500ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2500ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2500ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2500ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE25004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one25004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2500ONE4XI - SUCCEEDED TO PUT SHOT2ONE25004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE25004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2500ONE4XI *** FAILED TO PUT SHOT2ONE25004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2500ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one25004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one25004xi</nack2put4xi>" 
             
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2500ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one25004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
        
    except:
        print(" (STEP 3C/33) OF FIRE2500ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2500ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2500one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
